package rule;

import enumerate.Action;
import fighting.Attack;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class FireballCounter extends Rule {

	public FireballCounter(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {

		boolean enemyProjectileInAir = false;

		for (Attack a : gameState.getFrameData().getAttack()) {
			if (a.isPlayerNumber() != gameState.getPlayerNumber()) {
				enemyProjectileInAir = true;
				break;
			}
		}

		boolean enemyFireballAction = (gameState.getEnemyCharacterData()
				.getAction() == Action.STAND_D_DF_FB)
				|| (gameState.getEnemyCharacterData().getAction() == Action.STAND_D_DF_FA)
				|| (gameState.getEnemyCharacterData().getAction() == Action.STAND_D_DF_FC);

		return enemyFireballAction || enemyProjectileInAir;
	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("2 1 4 _ B");
	}

	@Override
	public int getPriority() {
		return -1;
	}

}
