package rule;

import commandcenter.CommandCenter;

import structs.CharacterData;
import structs.FrameData;
import structs.GameData;
import structs.MotionData;

/**
 * Interface for objects that specify relevant information about the game state.
 * 
 * @author Kevin Majchrzak
 * 
 */
public interface GameStateInterface {

	public FrameData getFrameData();

	public boolean getPlayerNumber();

	public GameData getGameData();

	public MotionData getMyMotionData();

	public MotionData getEnemyMotionData();

	public CharacterData getMyCharacterData();

	public CharacterData getEnemyCharacterData();

	public CommandCenter getCommandCenter();

}
