package rule;

import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class PermanentSlideCounter extends Rule {

	public PermanentSlideCounter(GameStateInterface gameState) {
		super(gameState, true);
	}

	@Override
	public boolean satisfied() {

		return true;

	}

	@Override
	public void execute() {

		if (gameState.getMyCharacterData().getState() == State.AIR) {
			if (gameState.getMyCharacterData().getSpeedY() > 0) {
				gameState.getCommandCenter().commandCall("2 1 4 _ B");
			} else {
				execCounter();
			}
		} else {
			execDodge();
		}

	}

	private void execCounter() {
		gameState.getCommandCenter().commandCall("AIR_D_DF_FB");
	}

	private void execDodge() {
		String jumpLeft, jumpRight;
		if (gameState.getMyCharacterData().isFront()) {
			jumpLeft = "BACK_JUMP";
			jumpRight = "FOR_JUMP";
		} else {
			jumpRight = "BACK_JUMP";
			jumpLeft = "FOR_JUMP";
		}

		if (Math.abs(gameState.getMyCharacterData().getX()
				- gameState.getEnemyCharacterData().getX()) > 300) {
			gameState.getCommandCenter().commandCall("JUMP");
		}

		if (gameState.getMyCharacterData().getX() < 300) {
			// jump away from left wall
			gameState.getCommandCenter().commandCall(jumpRight);
		} else if (gameState.getMyCharacterData().getX() > gameState
				.getGameData().getStageXMax() - 300) {
			// jump away from right wall
			gameState.getCommandCenter().commandCall(jumpLeft);
		} else if (gameState.getMyCharacterData().getX() < gameState
				.getEnemyCharacterData().getX()) {
			// jump away from enemy
			gameState.getCommandCenter().commandCall(jumpLeft);
		} else {
			// jump away from enemy
			gameState.getCommandCenter().commandCall(jumpRight);
		}
	}

	@Override
	public int getPriority() {
		return -1;
	}

}
