package rule;

import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class WrongDirectionCounter extends Rule {

	public WrongDirectionCounter(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {

		boolean myCharacterOnLeftSide = gameState.getCommandCenter().getMyX() < gameState
				.getCommandCenter().getEnemyX();
		boolean wrongDirection = (gameState.getEnemyCharacterData().isFront() && (myCharacterOnLeftSide))
				|| ((!gameState.getEnemyCharacterData().isFront()) && (!myCharacterOnLeftSide));

		return wrongDirection
				&& (gameState.getEnemyCharacterData().getState() != State.AIR);
	}

	@Override
	public void execute() {
		if ((gameState.getMyCharacterData().getState() != State.AIR)) {
			if ((gameState.getCommandCenter().getDistanceX() < 400)
					&& (gameState.getMyCharacterData().getEnergy() >= 300)) {
				// megafireball
				gameState.getCommandCenter().commandCall("STAND_D_DF_FC");
			} else {
				// slide
				gameState.getCommandCenter().commandCall("2 1 4 _ B");
			}
		} else {
			// hard air punch
			gameState.getCommandCenter().commandCall("9 2 3 6 _ B");
		}
	}

	@Override
	public int getPriority() {
		return 0;
	}

}
