import java.awt.Rectangle;

import structs.HitArea;


public final class HitBox {
	final int top;
	final int left;
	final int bottom;
	final int right;
	final Rectangle my;
	
	public HitBox(int top, int left, int bottom, int right)
	{
		this.top = top;
		this.left = left;
		this.bottom = bottom;
		this.right = right;
		my = new Rectangle(left,top,right-left,bottom-top);
	}
	
	public final HitBox getMovedBox(int x, int y)
	{
		return new HitBox(top+y,left+x,bottom+y,right+x);
	}
	
	public final int distance(HitBox box)
	{
		if(left < box.left)
			return box.left - right;
		return left - box.right;
	}
	
	public final int distance(HitArea area)
	{
		if(left < area.getL())
			return area.getL() - right;
		return left - area.getR();
	}
	
	public final boolean intersects(HitArea area)
	{
		Rectangle their = new Rectangle(area.getL(),area.getT(),area.getR()-area.getL(),area.getB()-area.getT());
		return my.intersects(their);
	}
}
